#property copyright "Copyright 2014, Mimi"
#property link      ""
#property version   "1.00"

extern double LotSize = 0.1;
extern double StopLoss = 10;
extern double TakeProfit = 20;
extern int    Slippage = 5;
extern int    MagicNumber = 123;

double currentlow;
double currenthigh;
double S1;
double lowest;
double highest;
double ES;
double EB;
double R1;
int    q;
int    BuyTicket = 0;
int    SellTicket = 0;
double UsePoint;
int    UseSlippage;


// Init function
int init()
{
UsePoint = PipPoint(Symbol());
UseSlippage = GetSlippage(Symbol(),Slippage);
return(UsePoint);
return(UseSlippage);
}
//---------------------------------------------------------------------------------------------------------------
// Start function
int start()
{
datetime now        = TimeCurrent();
          int bod        = now - now % 86400; // Beginning of the day
          int tomorrow   = bod + 86400;
          int expiration = tomorrow - 1;
          
for( q=0;q<OrdersTotal();q++)
  {
  if (OrderSelect(q, SELECT_BY_POS, MODE_TRADES)==true && OrderSymbol()==Symbol())
    {
    // checking positions for open orders.
    if (OrderType()==OP_BUYSTOP || OrderType() == OP_BUYLIMIT || OrderType () == OP_SELLLIMIT ||OrderType()==OP_SELLSTOP)
       return(0); 
    }  
  } 
  
  
int Ticket = BuyTicket + SellTicket;
lowest = iLow(NULL,PERIOD_D1,0);        // Today's low 
highest = iHigh(NULL,PERIOD_D1,0);      // Today's high

if( (highest - Bid) > (20 * Point))     //if current price is more than 20 pips below today's high
   {
   if(Ticket < 100)                     //This may work in the strategy tester, it will not in real-time 
      {
      S1 = highest - (40 * Point);      //---Calculating Support at 40 pips below today's high
      OrderSelect(BuyTicket,SELECT_BY_TICKET);      //1
      if( Bid > highest)                              //How can Bid be higher than today's high ???
         {
         bool Deleted = OrderDelete(BuyTicket,Green);
         }

      // Calculate stop loss and take profit
      if(StopLoss > 0)   double BuyStopLoss = S1 - (StopLoss * Point);
      if(TakeProfit > 0) double BuyTakeProfit = S1 + (TakeProfit * Point);  
// ----------------------------------------Open buy order
      EB = MathAbs((S1 - Bid));

      if (Bid > S1 && EB > (20 * Point))    //if Bid is at least 20 pips below S1 ie at least 60 pips below today's high
         { 
         BuyTicket = OrderSend(Symbol(),OP_BUYLIMIT,LotSize,S1,UseSlippage,BuyStopLoss,BuyTakeProfit,"Buy Stop Order",MagicNumber,expiration,Green);
         SellTicket = 0;
         }
      else if(Bid < S1 && EB > (20 * Point))
         {
         BuyTicket = OrderSend(Symbol(),OP_BUYSTOP,LotSize,S1,UseSlippage,BuyStopLoss,BuyTakeProfit,"Buy Limit Order",MagicNumber,expiration,Green);
         SellTicket = 0;
         }
      }
   }
else if( (Bid - lowest)> (20 * Point))       
   {
   if(Ticket < 100 )
      {

      R1 = lowest + (40 * Point);  //---Calculating resistance
      OrderSelect(SellTicket,SELECT_BY_TICKET);
      if( Bid < lowest)
         {
        Deleted = OrderDelete(SellTicket,Red);
         }

      if(StopLoss > 0)   double SellStopLoss = R1 + (StopLoss * Point);
      if(TakeProfit > 0) double SellTakeProfit = R1 -(TakeProfit * Point);

// Sell Order
      ES = MathAbs((R1 - Ask));
      if(Ask < R1 && ES >(20 * Point))
         {
         SellTicket = OrderSend(Symbol(),OP_SELLLIMIT,LotSize,R1,UseSlippage,SellStopLoss,SellTakeProfit,"Sell Stop Order",MagicNumber,expiration,Red);
         BuyTicket = 0;
         }
      else if(Ask > R1 && ES >(20 * Point))
         {
         SellTicket = OrderSend(Symbol(),OP_SELLSTOP,LotSize,R1,UseSlippage,SellStopLoss,SellTakeProfit,"Sell Limit Order",MagicNumber,expiration,Red);
         BuyTicket = 0;
         }
      }
   }
return(0);
}

//--------------------------------------------------------------------------------------------------------

// Pip Point Function
double PipPoint(string Currency)
{
int CalcDigits = MarketInfo(Currency,MODE_DIGITS);
if(CalcDigits == 2 || CalcDigits == 3) double CalcPoint = 0.01;
else if(CalcDigits == 4 || CalcDigits == 5) CalcPoint = 0.0001;
return(CalcPoint);
}

// Get Slippage Function
int GetSlippage(string Currency, int SlippagePips)
{
int CalcDigits = MarketInfo(Currency,MODE_DIGITS);
if(CalcDigits == 2 || CalcDigits == 4) double CalcSlippage = SlippagePips;
else if(CalcDigits == 3 || CalcDigits == 5) CalcSlippage = SlippagePips * 10;
return(CalcSlippage);
}
